export const enum ApiErrorCodes {
  // Basic errors
  SERVER = 1,
  DATABASE = 2,
  NOT_SIGNED = 3,
  FORBIDDEN = 4,
  FORBIDDEN_UPDATE = 5,
  FORBIDDEN_DELETE = 6,
  NOT_FOUND = 7,

  // ==============
  //   RESSOURCES
  // ==============
  // User
  USER_NAME_TOO_SHORT = 101,
  USER_PASSWORD_TOO_SHORT = 102,
  USER_NAME_ALREADY_EXISTS = 103,
  USER_NOT_FOUND = 104,
  USER_WRONG_PASSWORD = 105,

  // Role
  ROLE_NAME_TOO_LONG = 201,
  ROLE_DESC_TOO_LONG = 202,
  ROLE_ALREADY_EXISTS = 203,

  // Recipe
  RECIPE_NAME_TOO_LONG = 301,
  RECIPE_WRONG_DIFFICULTY = 302,
  RECIPE_WRONG_PREP_TIME = 303,
  RECIPE_WRONG_REST_TIME = 304,
  RECIPE_WRONG_COOK_TIME = 305,
  RECIPE_DESC_TOO_LONG = 306,
  RECIPE_NOTE_TOO_LONG = 307,
  RECIPE_WRONG_PERSONS = 308,
  RECIPE_INGREDIENT_NOT_IN = 309,
  RECIPE_WRONG_UNIT_ID = 310,
  RECIPE_WRONG_QUANTITY = 311,

  // Step
  STEP_WRONG_RECIPE_ID = 401,
  STEP_RECIPE_NOT_FOUND = 402,
  STEP_FORBIDDEN_CREATE = 403,
  STEP_WRONG_ORDER = 404,
  STEP_INSTRUCTION_TOO_LONG = 405,

  // Ingredient
  INGREDIENT_NAME_TOO_LONG = 501,

  // ===============
  //   MIDDLEWARES
  // ===============
  // Auth
  AUTH_NO_HEADER = 1001,
  AUTH_WRONG_HEADER = 1002,
  AUTH_USER_NOT_FOUND = 1003,
  AUTH_TOKEN_INVALID = 1004,
  AUTH_TOKEN_EXPIRED = 1005,
  AUTH_INVALID_SIGN = 1006,

  // Check if exists
  CHECK_EXISTS_WRONG_ID = 1021,
  CHECK_EXISTS_NOT_FOUND = 1022,

  // Not implemented
  NOT_IMPLEMENTED = 1041,

  // Query options
  QUERY_OPTIONS_FIELDS = 1061,
  QUERY_OPTIONS_INCLUDE = 1062,
  QUERY_OPTIONS_SORT = 1063,
  QUERY_OPTIONS_SORT_SELECTED = 1064,
  QUERY_OPTIONS_LIMIT = 1065,
  QUERY_OPTIONS_PAGE = 1066,

  // Required body params
  REQUIRED_BODY_PARAMS = 1081,
}
